#import <Cocoa/Cocoa.h>
#import "QCGLCIImage.h"
#import "QCOpenGLContext-QCUtilities.h"

@interface ImageDownloaderBlockingCache : NSObject
{
	QCOpenGLContext *_context;

	// our cache is a dictionary of ImageDownloaderBlockingCacheContainers, keyed by NSURL.
	NSMutableDictionary *_cache;
	
	// sum of estimatedSize of all images in _cache at any given time
	unsigned long int _cacheMemory;
}
+ (ImageDownloaderBlockingCache *)cacheForContext:(QCOpenGLContext *)glContext;
+ (unsigned long int)totalCacheMemory;
+ (void)cleanAllCaches;
+ (float)cacheVRAMLimitPercent;

- (id)initWithContext:(QCOpenGLContext *)context;
- (QCGLCIImage *) requestImageUsingCache:(NSURL *)url;
- (void)removeFromCache:(NSURL *)url;
- (void)clearCache;
- (void)cleanCache;
- (unsigned long int)cacheMemory;
@end
