#import "ImageDownloaderBlockingPatch.h"
#import "ImageDownloaderBlockingCache.h"
#import "QCGLCIImage.h"

#import <Quartz/Quartz.h>
#import <OpenGL/CGLMacro.h>


@implementation ImageDownloaderBlockingPatch : QCPatch

+ (int)executionMode
{
	return 2;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 0;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	_currentURL=[[NSString alloc] initWithString:[inputURL stringValue]];

	return z;
}


- (id)setup:(id)fp8
{
	return fp8;
}
- (void)cleanup:(id)glContext
{
//	NSLog(@"ImageDownloaderBlockingPatch::cleanup(%08x)",glContext);
	[[ImageDownloaderBlockingCache cacheForContext:glContext] clearCache];
}


- (void)enable:(id)fp8
{
	firstExecuteAfterEnabled=true;
}
- (void)disable:(id)fp8
{
}




- (BOOL)execute:(id)glContext time:(double)fp12 arguments:(id)fp20
{
	if(
		firstExecuteAfterEnabled
		|| ![[inputURL stringValue] isEqualToString:_currentURL]
	)
	{
//		NSLog(@"ImageDownloaderBlockingPatch::execute(%08x)  URL changed to \"%@\"",glContext,[inputURL stringValue]);

		[_currentURL release];
		_currentURL=[[NSString alloc] initWithString:[inputURL stringValue]];

		NSURL *url=[NSURL URLWithString:_currentURL];
		QCGLCIImage *glimage=
			[[ImageDownloaderBlockingCache cacheForContext:glContext] requestImageUsingCache:url];
//		[url release];

		[outputImage setImageValue:glimage];
		
		firstExecuteAfterEnabled=false;
	}

	return YES;
}

@end
